----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    06:15:01 11/28/2016 
-- Design Name: 
-- Module Name:    RAM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DPRAM is
   generic(
      B: natural := 16; -- number of bits
      W: natural := 11 -- number of address bits
   );
   port(
      clk: in std_logic;
      we: in std_logic;
      w_data: in std_logic_vector (B-1 downto 0);
      w_addr: in std_logic_vector (W - 1 downto 0);
      r_addr: in std_logic_vector (W - 1 downto 0);
      r_data: out std_logic_vector (B-1 downto 0)
   );
end DPRAM;

architecture Behavioral of DPRAM is
  type ram_type is array (2 ** W - 1 downto 0) of
           std_logic_vector (B - 1 downto 0);
  signal ram: ram_type := (others => (others => '0')); 
 attribute ram_style: string;
 attribute ram_style of ram : signal is "block";
Begin
 process(clk)
  begin
   if ((clk'event) and (clk = '1')) then
      if (we ='1') then
         ram(to_integer(unsigned(w_addr))) <= w_data;
      end if;
      r_data <= ram(to_integer(unsigned(r_addr)));
   end if;
 end process;
end Behavioral;

