----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:24:05 11/24/2016 
-- Design Name: 
-- Module Name:    SINC2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_arith.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SINC2 is 
   generic(
      B: natural:=24 -- number of bits
   );
   port(RES, DIN, CLK, FSCLK, FBWCLK : in std_logic; 
        DOUT : out std_logic_vector(B downto 0)); 
end SINC2; 

architecture RTL of SINC2 is 
  signal DX : std_logic_vector(B downto 0); 
  signal DX1 : std_logic_vector(B-1 downto 0); 
  signal D0, D1, D2, D3 : std_logic_vector(B downto 0); 
  signal C0, C1, C2, C3 : std_logic_vector(B downto 0); 
begin 
   process(CLK, FSCLK, RES) 
   begin 
      if RES = '1' then 
         C1 <= (others => '0'); 
         C3 <= (others => '0'); 
      elsif CLK'event and CLK = '1' and FSCLK = '1' then 
         C1 <= C0; 
         C3 <= C2; 
      end if; 
   end process;
	DX1 <= (others => '0');
   DX <= DX1 & DIN;	
   C0 <= unsigned(DX) + unsigned(C1);
   C2 <= unsigned(C1) + unsigned(C3);
   
   process(RES, CLK, FBWCLK) 
   begin 
      if RES = '1' then 
         D0 <= (others => '0'); 
         D1 <= (others => '0'); 
         D3 <= (others => '0'); 
      elsif CLK'event and CLK = '1' and FBWCLK = '1' then 
         D0 <= C2; 
         D1 <= D0; 
         D3 <= D2; 
      end if; 
   end process; 
   D2 <= unsigned(D0) - unsigned(D1); 
   DOUT <= unsigned(D2) - unsigned(D3); 
 
end RTL; 
