----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:24:05 11/24/2016 
-- Design Name: 
-- Module Name:    SINC2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_arith.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SINC2X is 
   port(RES, DIN, CLK, FSCLK, FBWCLK : in std_logic; 
        DOUT : out std_logic_vector(24 downto 0)); 
end SINC2X; 

architecture RTL of SINC2X is 
  signal DX, DY : std_logic_vector(24 downto 0); 
  signal D0, D1, D2, D3 : std_logic_vector(24 downto 0); 
  signal C0, C1, C2, C3 : std_logic_vector(24 downto 0); 
begin 
   process(CLK, FSCLK, RES) 
   begin 
      if RES = '1' or FBWCLK = '1' then 
         DX <= "000000000000000000000000" & DIN;	
         DY <= "000000000000000000000000" & DIN;	
      elsif CLK'event and CLK = '1' and FSCLK = '1' then 
         DX <= unsigned(DX) + unsigned(D1);
         DY <= unsigned(DY) + unsigned(DX);
      end if; 
   end process;

   DOUT <= DY; 
 
end RTL; 
