----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:24:58 11/26/2015 
-- Design Name: 
-- Module Name:    Sine - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Sine is
    Port ( COUNT : in  STD_LOGIC_VECTOR (8 downto 0);
           SIN : out  STD_LOGIC_VECTOR (15 downto 0));
end Sine;



architecture Behavioral of Sine is
type ROM_TYPE is array (0 to 2**9 - 1 ) of 
                std_logic_vector(7 downto 0);
constant ROM : ROM_TYPE :=
-- 64 x 8 = 512 vectors
   ( x"7F",x"BF",x"EE",x"FE",x"EC",x"BC",x"7C",x"3C",
x"0F",x"00",x"13",x"44",x"85",x"C5",x"F1",x"FE",
x"E9",x"B7",x"76",x"37",x"0C",x"00",x"17",x"4A",
x"8B",x"CA",x"F4",x"FE",x"E5",x"B1",x"6F",x"32",
x"09",x"01",x"1A",x"50",x"92",x"CF",x"F6",x"FD",
x"E2",x"AB",x"69",x"2D",x"07",x"02",x"1E",x"56",
x"98",x"D3",x"F8",x"FC",x"DD",x"A6",x"63",x"28",
x"05",x"03",x"23",x"5B",x"9E",x"D8",x"FA",x"FA",
x"D9",x"9F",x"5D",x"24",x"03",x"05",x"27",x"62",
x"A4",x"DC",x"FB",x"F9",x"D5",x"99",x"57",x"1F",
x"02",x"06",x"2C",x"68",x"AA",x"E1",x"FD",x"F7",
x"D0",x"93",x"51",x"1B",x"01",x"09",x"31",x"6E",
x"B0",x"E4",x"FE",x"F4",x"CB",x"8D",x"4B",x"18",
x"00",x"0B",x"36",x"74",x"B6",x"E8",x"FE",x"F2",
x"C6",x"87",x"46",x"14",x"00",x"0E",x"3B",x"7A",
x"BB",x"EC",x"FE",x"EF",x"C1",x"81",x"40",x"11",
x"00",x"11",x"40",x"81",x"C1",x"EF",x"FE",x"EC",
x"BB",x"7A",x"3B",x"0E",x"00",x"14",x"46",x"87",
x"C6",x"F2",x"FE",x"E8",x"B6",x"74",x"36",x"0B",
x"00",x"18",x"4B",x"8D",x"CB",x"F4",x"FE",x"E4",
x"B0",x"6E",x"31",x"09",x"01",x"1B",x"51",x"93",
x"D0",x"F7",x"FD",x"E1",x"AA",x"68",x"2C",x"06",
x"02",x"1F",x"57",x"99",x"D5",x"F9",x"FB",x"DC",
x"A4",x"62",x"27",x"05",x"03",x"24",x"5D",x"9F",
x"D9",x"FA",x"FA",x"D8",x"9E",x"5B",x"23",x"03",
x"05",x"28",x"63",x"A6",x"DD",x"FC",x"F8",x"D3",
x"98",x"56",x"1E",x"02",x"07",x"2D",x"69",x"AB",
x"E2",x"FD",x"F6",x"CF",x"92",x"50",x"1A",x"01",
x"09",x"32",x"6F",x"B1",x"E5",x"FE",x"F4",x"CA",
x"8B",x"4A",x"17",x"00",x"0C",x"37",x"76",x"B7",
x"E9",x"FE",x"F1",x"C5",x"85",x"44",x"13",x"00",
x"0F",x"3C",x"7C",x"BC",x"EC",x"FE",x"EE",x"BF",
x"7F",x"3F",x"10",x"00",x"12",x"42",x"82",x"C2",
x"EF",x"FE",x"EB",x"BA",x"79",x"39",x"0D",x"00",
x"15",x"47",x"88",x"C7",x"F2",x"FE",x"E7",x"B4",
x"73",x"34",x"0A",x"00",x"19",x"4D",x"8F",x"CC",
x"F5",x"FD",x"E4",x"AE",x"6C",x"2F",x"08",x"01",
x"1C",x"53",x"95",x"D1",x"F7",x"FC",x"E0",x"A8",
x"66",x"2B",x"06",x"02",x"21",x"58",x"9B",x"D6",
x"F9",x"FB",x"DB",x"A3",x"60",x"26",x"04",x"04",
x"25",x"5F",x"A1",x"DA",x"FB",x"F9",x"D7",x"9C",
x"5A",x"22",x"03",x"05",x"29",x"65",x"A7",x"DF",
x"FC",x"F8",x"D2",x"96",x"54",x"1D",x"01",x"07",
x"2E",x"6B",x"AD",x"E3",x"FD",x"F5",x"CD",x"90",
x"4E",x"1A",x"00",x"0A",x"33",x"71",x"B3",x"E6",
x"FE",x"F3",x"C8",x"8A",x"48",x"16",x"00",x"0C",
x"38",x"77",x"B8",x"EA",x"FE",x"F0",x"C3",x"84",
x"43",x"12",x"00",x"0F",x"3D",x"7D",x"BE",x"ED",
x"FF",x"ED",x"BE",x"7D",x"3D",x"0F",x"00",x"12",
x"43",x"84",x"C3",x"F0",x"FE",x"EA",x"B8",x"77",
x"38",x"0C",x"00",x"16",x"48",x"8A",x"C8",x"F3",
x"FE",x"E6",x"B3",x"71",x"33",x"0A",x"00",x"1A",
x"4E",x"90",x"CD",x"F5",x"FD",x"E3",x"AD",x"6B",
x"2E",x"07",x"01",x"1D",x"54",x"96",x"D2",x"F8",
x"FC",x"DF",x"A7",x"65",x"29",x"05",x"03",x"22",
x"5A",x"9C",x"D7",x"F9",x"FB",x"DA",x"A1",x"5F",
x"25",x"04",x"04",x"26",x"60",x"A3",x"DB",x"FB",
x"F9",x"D6",x"9B",x"58",x"21",x"02",x"06",x"2B",
x"66",x"A8",x"E0",x"FC",x"F7",x"D1",x"95",x"53",
x"1C",x"01",x"08",x"2F",x"6C",x"AE",x"E4",x"FD",
x"F5",x"CC",x"8F",x"4D",x"19",x"00",x"0A",x"34",
x"73",x"B4",x"E7",x"FE",x"F2",x"C7",x"88",x"47",
x"15",x"00",x"0D",x"39",x"79",x"BA",x"EB",x"FE",
x"EF",x"C2",x"82",x"42",x"12",x"00",x"10",x"3F"
  );  
  
begin
   SIN <= ROM(to_integer(unsigned(COUNT))) & "00000000";  -- Lesezugriff
end Behavioral;

